"use strict";

var _path = _interopRequireDefault(require("path"));

var _pundleApi = require("pundle-api");

var _package = _interopRequireDefault(require("../package.json"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function createComponent({
  extensions = ['.less'],
  options = {}
} = {}) {
  return (0, _pundleApi.createFileTransformer)({
    name: _package.default.name,
    version: _package.default.version,
    priority: 2000,

    callback({
      file,
      context
    }) {
      return _asyncToGenerator(function* () {
        const extName = _path.default.extname(file.filePath);

        if (!extensions.includes(extName)) return null;
        const exported = yield (0, _pundleApi.loadLocalFromContext)(context, 'less');
        const processed = yield exported.render(typeof file.contents === 'string' ? file.contents : file.contents.toString(), _objectSpread({
          filename: file.filePath,
          sourceMap: {}
        }, options));
        return {
          contents: processed.css,
          sourceMap: JSON.parse(processed.map)
        };
      })();
    }

  });
}

module.exports = createComponent;